/*------------------------------------------------*/
/* konverze/konverze.c                            */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <locale.h>
#include <limits.h>
#include <stdlib.h>
#include <wchar.h>
#include <string.h>
#include "tobin.h"

/**
* Zjisti pocet znaku v multibyte retezci.
*/
size_t mbslen (const char *s)
{
    mbstate_t state;
    size_t result = 0;
    size_t nbytes;
    memset (&state, '\0', sizeof (state));
    while ((nbytes = mbrlen (s, MB_LEN_MAX, &state)) > 0)
    {
        if (nbytes >= (size_t) -2)
            /* Something is wrong.  */
            return (size_t) -1;
        s += nbytes;
        ++result;
    }
    return result;
}

int main(void) {
    wchar_t ws[1];
    char mb[MB_LEN_MAX +1];
    int len;
    mbstate_t state;

    memset (&state, '\0', sizeof (state));
    setlocale(LC_ALL,"");

    printf("mbsinit(state) = %i\n", mbsinit (&state));
    printf("LC_CTYPE = %s\n",setlocale(LC_CTYPE,""));
    printf("MB_LEN_MAX = %i\n", MB_LEN_MAX);
    printf("MB_CUR_MAX = %u\n", MB_CUR_MAX);
    printf("sizeof(wchar_t) = %li\n", sizeof(wchar_t));

    printf("btowc(a) = %lc\n", btowc('a'));
    printf("btowc(č) = %s\n", btowc(L'č') == EOF ? "EOF" :"iso/win");
    mbrtowc(ws,"č",4, &state);
    printf("mbrtowc(č) = %lc = %s\n", (wint_t) ws[0], wstobin(ws[0]));
    printf("mbsinit(state) = %i\n", mbsinit (&state));

    len = wcrtomb(mb, ws[0], &state);
    mb[len] = '\0';
    printf("wcrtomb(%lc) = %s\n", (wint_t) ws[0], mb);
    printf("mbsinit(state) = %i\n", mbsinit (&state));

    mbrtowc(ws,"A",4, &state);
    printf("mbrtowc(A) = %lc = %s\n", (wint_t) ws[0], wstobin(ws[0]));

    memset (&state, '\0', sizeof (state));
    printf("bytesInUTF8(☹) = %u\n", mbrlen("☹", MB_LEN_MAX, &state));
    printf("znaku v (☹☹☹☹) = %u\n", mbslen("☹☹☹☹"));

    return 0;
}

/*------------------------------------------------*/
